<?php

namespace Drupal\commerce_checkout_link;

use Drupal\commerce_order\Entity\OrderInterface;
use Drupal\Component\Utility\Crypt;
use Drupal\Core\Site\Settings;
use Drupal\Core\Url;

/**
 * CheckoutLinkManager service.
 */
class CheckoutLinkManager {

  /**
   * Helper.
   */
  public static function generateUrl(OrderInterface $order) {
    $timestamp = time();
    return new Url('commerce_checkout_link.checkout_link', [
      'commerce_order' => $order->id(),
      'timestamp' => $timestamp,
      'hash' => self::generateHash($timestamp, $order),
    ]);
  }

  /**
   * Helper.
   */
  public static function generateHash($timestamp, OrderInterface $commerce_order) {
    return Crypt::hmacBase64($timestamp . $commerce_order->id() . $commerce_order->getChangedTime(), Settings::getHashSalt());
  }

}
